#include "stdafx.h"

#include "util.h"


stRes CalculateResize(stRes stInput, int iResol, int iFormat, int iDar, int iZoom)
{
	stRes ret;
	double dDar;
	int iOX,iOY,iDarX,iDarY,iOXori,iOYori;
	int Zoom;

	Zoom=100;
	if (iZoom==1) Zoom=110;
	if (iZoom==2) Zoom=115;
	if (iZoom==3) Zoom=120;

	if (iDar==DAR4_3)
	{
		dDar=4.0/3.0;
		iDarX=4;
		iDarY=3;
	}
	else
	{
		dDar=16.0/9.0;
		iDarX=16;
		iDarY=9;
	}
	if (iFormat==NTSC)
	{
		if		(iResol == DVD)		{iOX=720; iOY=480;}
		else if (iResol == SVCD)	{iOX=480; iOY=480;}
		else if (iResol == CVD)		{iOX=352; iOY=480;}
		else						{iOX=352; iOY=240;}
	}
	else
	{
		if		(iResol == DVD)		{iOX=720; iOY=576;}
		else if (iResol == SVCD)	{iOX=480; iOY=576;}
		else if (iResol == CVD)		{iOX=352; iOY=576;}
		else						{iOX=352; iOY=288;}
	}

	iOXori=iOX;
	iOYori=iOY;

	iOX=(Zoom*iOX+50)/100;
	iOY=(Zoom*iOY+50)/100;

	if ( ((double)stInput.iX)/(double)stInput.iY > dDar)
	{
// Add Horizontal bars
		ret.iborderX=0;
		ret.iX=iOX;
// SIMPLE
//		ret.iY=(stInput.iY*iDarX*iOY)/(stInput.iX*iDarY);
// ROUNDED
//		ret.iY=((stInput.iY*iDarX*iOY)+((stInput.iX*iDarY)/2))/(stInput.iX*iDarY);
// RESIZE TO EVEN NUMBERS
		ret.iY=2*(((stInput.iY*iDarX*iOY)+((stInput.iX*iDarY*2)/2))/(stInput.iX*iDarY*2));

		ret.iCropX=(iOX-iOXori)/2;

		if (ret.iY > iOYori)
		{
			ret.iborderY=0;
			ret.iCropY=(ret.iY-iOYori)/2;
		}
		else
		{
			ret.iborderY=(iOYori-ret.iY)/2;
			ret.iCropY=0;
		}
	}
	else
	{
// Add Vertical bars
		ret.iborderY=0;
		ret.iY=iOY;
// SIMPLE
//		ret.iX=(stInput.iX*iDarY*iOX)/(stInput.iY*iDarX);
// ROUNDED
//		ret.iX=((stInput.iX*iDarY*iOX)+((stInput.iY*iDarX)/2))/(stInput.iY*iDarX);
// RESIZE TO EVEN NUMBERS
		ret.iX=2*(((stInput.iX*iDarY*iOX)+((stInput.iY*iDarX*2)/2))/(stInput.iY*iDarX*2));

		ret.iCropY=(iOY-iOYori)/2;

		if (ret.iX > iOXori)
		{
			ret.iborderX=0;
			ret.iCropX=(ret.iX-iOXori)/2;
		}
		else
		{
			ret.iborderX=(iOXori-ret.iX)/2;
			ret.iCropX=0;
		}

	}

	return ret;
}